module Others where

open import Data.Unit.Base using (⊤; tt)
open import Data.Nat.Base
open import Data.Nat.Properties
open import Data.Nat.Properties.Simple
open import Data.Fin hiding (_+_; _≤_; _<_)
open import Data.Sum
open import Data.Product
open import Data.Maybe.Base
open import Function using (_∘_)
open import Relation.Binary.PropositionalEquality
open ≡-Reasoning

open import Regular
open import Properties
open import Subst
open import Mgu
open import STLC

---------------------------------------------------------------
NatF : Code
NatF = U ⊕ I

NatThree : μ NatF 0
NatThree = ⟨ inj₂ ⟨ inj₂ ⟨ inj₂ ⟨ inj₁ tt ⟩ ⟩ ⟩ ⟩

lift+ : {F : Code} → {m : ℕ} →(m′ : ℕ) → μ F m → μ F (m + m′)
lift+ m′ t = ⟪cata⟫ (λ x → ⟪ inject+ m′ x ⟫) t

liftAList : {F : Code} → {l m : ℕ} → (k : ℕ) →
        (σ : AList F l m) → AList F (k + l) (k + m)
liftAList = {!!}

liftAList′ : {F : Code} → {l l′ m m′ : ℕ} → (k : ℕ) →
        l′ ≡ k + l → m′ ≡ k + m → (σ : AList F l m) → AList F l′ m′
liftAList′ = {!!}

liftAList≤′ : {F : Code} → {l m m′ : ℕ} → (m≤m′ : m ≤ m′) →
        (σ : AList F l m) → AList F ((m′ ∸ m) + l) m′
liftAList≤′ = {!!}

TypeEx₁ : μ TypeF 0
TypeEx₁ = (TUnit ⇒ TUnit) ⇒ TUnit

TypeEx₂ : μ TypeF 1
TypeEx₂ = (TUnit ⇒ ⟪ zero ⟫) ⇒ ⟪ zero ⟫

TypeEx₃ : μ TypeF 3
TypeEx₃ = (TUnit ⇒ ⟪ suc (suc zero) ⟫) ⇒ ⟪ zero ⟫

TypeEx₄ : μ TypeF 4
TypeEx₄ = (TUnit ⇒ ⟪ suc (suc zero) ⟫) ⇒ ⟪ zero ⟫

TypeEx₅ : μ TypeF 2
TypeEx₅ = (TUnit ⇒ ⟪ suc zero ⟫) ⇒ ⟪ zero ⟫
